package eu.mhsl.minenet.minigames.instance.game.minigame.config.restriction;

import eu.mhsl.minenet.minigames.message.component.TranslatedComponent;

public class Restriction {
    final private TranslatedComponent name;
    final private TranslatedComponent description;
    final private TranslatedComponent warnMessage;

    final private Type type;

    public Restriction(TranslatedComponent name, TranslatedComponent description, TranslatedComponent warnMessage, Type type) {
        this.name = name;
        this.description = description;
        this.warnMessage = warnMessage;
        this.type = type;

        if(this.warnMessage == null && this.type.equals(Type.WARN)) {
            throw new IllegalStateException("warnMessage cannot be null when RestrictionType is WARN");
        }
    }

    public TranslatedComponent getName() {
        return name;
    }

    public TranslatedComponent getDescription() {
        return description;
    }

    public TranslatedComponent getWarnMessage() {
        return warnMessage;
    }

    public Type getType() {
        return type;
    }

    public enum Type {
        OK,
        WARN,
        FAIL,
    }
}

